#include <string.h>
#include <aterm2.h>
#include "Booleans.h"

typedef struct ATerm _SDFCHARLIST;

static ATermList SDFconvertStringToChars(char *str)
{
  int i;
  ATermList list = ATempty;

  for(i = strlen(str) - 1; i >= 0; i--) {
    list = ATinsert(list, (ATerm) ATmakeInt(str[i]));
  }

  return list;
}

static char * SDFconvertCharsToString(ATermList list)
{
  int i;
  char *tmp = (char*) malloc((1 + ATgetLength(list)) * sizeof(char));

  for(i = 0; !ATisEmpty(list); list = ATgetNext(list), i++) {
    tmp[i] = ATgetInt((ATermInt) ATgetFirst(list));
  }

  tmp[i] = '\0';
  return tmp;
}

ATbool SDFisValidCHARLIST(SDFCHARLIST arg)
{
  return ATtrue;
}

ATbool SDFisCHARLISTString(SDFCHARLIST arg)
{
  return ATtrue;
}

char*  SDFgetCHARLISTString(SDFCHARLIST arg)
{
  return SDFconvertCharsToString((ATermList) arg);
}

SDFCHARLIST  SDFsetCHARLISTString(SDFCHARLIST arg, char *str)
{
  return (SDFCHARLIST) SDFconvertStringToChars(str);
}

ATerm  SDFCHARLISTToTerm(SDFCHARLIST arg)
{
  return (ATerm) arg;
}

SDFCHARLIST SDFCHARLISTFromTerm(ATerm trm)
{
  return (SDFCHARLIST) trm;
}

SDFCHARLIST SDFmakeCHARLISTString(char *str)
{
  return (SDFCHARLIST) SDFconvertStringToChars(str);
}
